/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package de.laliluna.example.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.actions.DispatchAction;
import org.hibernate.StaleObjectStateException;

import de.laliluna.example.domain.Hedgehog;
import de.laliluna.example.service.HedgehogService;
import de.laliluna.example.service.HedgehogServiceImp;
import de.laliluna.example.struts.Globals;
import de.laliluna.example.struts.form.HedgehogForm;

public class HedgehogAction extends DispatchAction {
	/**
     * Loads an existing hedgehog if an id is specified, else just displays the
     * edit form.
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return ActionForward
     */
	public ActionForward unspecified(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		HedgehogForm hedgehogForm = (HedgehogForm) form;
		if (hedgehogForm.getId() != null) {
			HedgehogService hedgehogService = new HedgehogServiceImp();
			Hedgehog hedgehog = hedgehogService.findById(hedgehogForm.getId());
			if (hedgehog != null)
				hedgehogForm.setHedgehog(hedgehog);
			else // bad id
				hedgehogForm.setId(null);
		}
		return mapping.findForward(Globals.SUCCESS);
	}

	/**
     * saves or updates an hedgehog
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     */
	public ActionForward save(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		HedgehogForm hedgehogForm = (HedgehogForm) form;
		ActionMessages messages = new ActionMessages();

		HedgehogService hedgehogService = new HedgehogServiceImp();

		try {
			hedgehogService.saveOrUpdateHedgehog(hedgehogForm.getHedgehog());
		} catch (StaleObjectStateException e) {

			messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
					"errors.rowWasUpdatedByOtherUser"));
			saveErrors(request, messages);
		}

		/* if no message exist, data is saved and we forward to the list, else we redisplay the form */
		if (messages.size() == 0)
			return mapping.findForward(Globals.EXIT);
		else
			return unspecified(mapping, form, request, response);
	}

	/* (non-Javadoc)
	 * @see org.apache.struts.actions.DispatchAction#cancelled(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	@Override
	protected ActionForward cancelled(ActionMapping mapping, ActionForm arg1, HttpServletRequest arg2, HttpServletResponse arg3) throws Exception {
		return mapping.findForward(Globals.EXIT);
		
	}
	
	

}