package de.laliluna.sandcastle;

import java.util.List;
import java.util.logging.Logger;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;


@Stateless
public class SandcastleServiceBean implements SandcastleService {
private static Logger log = Logger.getLogger(SandcastleServiceBean.class.toString());
	@PersistenceContext
	private EntityManager em ;
	/* (non-Javadoc)
	 * @see de.laliluna.sandcastle.SandcastleService#create(de.laliluna.sandcastle.Sandcastle)
	 */
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void create(Sandcastle sandcastle) {
		log.info("Creating: "+sandcastle);
		em.persist(sandcastle);
		
	}

	/* (non-Javadoc)
	 * @see de.laliluna.sandcastle.SandcastleService#delete(de.laliluna.sandcastle.Sandcastle)
	 */
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public void delete(Sandcastle sandcastle) {
		log.info("delete: "+sandcastle);
		Sandcastle ref = em.getReference(Sandcastle.class, sandcastle.getId());
		em.remove(ref);
		
	}

	/* (non-Javadoc)
	 * @see de.laliluna.sandcastle.SandcastleService#findAll()
	 */
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	public List<Sandcastle> findAll() {
		log.info("finding all castles ");
		return em.createQuery("select s from Sandcastle s").getResultList();
	}

}
