
package de.laliluna.component.joincolumns;

import java.util.List;
import java.util.Random;

import org.hibernate.LockMode;
import org.hibernate.LockOptions;
import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;

/**
 * @author hennebrueder
 */
public class TestComponentJoinColumns extends BasicTest {

	/**
     * @param args
     */
	public static void main(String[] args) {
		ElbowRest elbowRest = create();
		change(elbowRest);

		query();

	}

	private static void query() {
		log.debug("query");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		List<OldDeveloper> list = session.createQuery(
				"from OldDeveloper o where o.elbowRest.id.articleGroup = ?")
				.setInteger(0, 55).list();
		for (OldDeveloper developer : list) {
			System.out.println(developer);
		}
		session.getTransaction().commit();

	}

	private static void change(ElbowRest elbowRest) {
		log.debug("change");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		// we expect the session to have been closed so reattach the elbowRestk
		session.buildLockRequest(LockOptions.NONE).lock(elbowRest);

		// create a new elbowrest
		Random r = new Random();
		ElbowRest newRest = new ElbowRest(new ElbowRest.ElbowRestId(55, r
				.nextInt(20)), 255f);
		session.save(newRest);
		// change elbowrest of first developer to come across
		OldDeveloper oldDeveloper = (OldDeveloper) session
				.createQuery(
						"from OldDeveloper o where o.elbowRest.id.articleGroup = ? and o.elbowRest.id.articleNumber = ?")
				.setInteger(0, elbowRest.getId().getArticleGroup()).setInteger(
						1, elbowRest.getId().getArticleNumber()).list()
				.iterator().next();

		oldDeveloper.setElbowRest(newRest);

		session.getTransaction().commit();

	}

	private static ElbowRest create() {
		log.debug("create");
		Random r = new Random();
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		OldDeveloper oldDeveloper = new OldDeveloper("Sebastian");
		ElbowRest elbowRest = new ElbowRest(new ElbowRest.ElbowRestId(r.nextInt(100), r
				.nextInt(100)), 5.55f);
		oldDeveloper.setElbowRest(elbowRest);
		session.save(elbowRest);
		session.save(oldDeveloper);
		session.getTransaction().commit();
		return elbowRest;
	}
}
