
package de.laliluna.component.simple;

import java.util.List;

import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;

/**
 * @author hennebrueder
 */
public class TestComponentSimple extends BasicTest {

	/**
     * @param args
     */
	public static void main(String[] args) {
		clean();
		create();
		select();

	}

	private static void clean() {
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		session.createQuery("delete from Soup").executeUpdate();

		session.getTransaction().commit();
		
	}

	private static void select() {
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		List<Soup> list = session.createQuery(
				"from Soup s where s.taste.evaluation = ?").setString(0,
				"best eaten so far").list();
		for (Soup soup : list) {
			System.out.println(soup);
		}

		session.getTransaction().commit();

	}

	private static void create() {
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		Soup soup = new Soup("Vegetable soup");
		Taste taste = new Taste();
		taste.setEvaluation("best eaten so far");
		taste.setFirstImpression("incredible");
		soup.setTaste(taste);
		Recipe recipe = new Recipe();
		recipe.setDescription("wash and cut vegetables\nadd water\ncook");
		recipe.setIngredients("choice of vegetables you like");
		/*
         * We should set the soup property of recipe as well. We do need it for saving but the recipe would not be updated.
         * It is set, if we load the soup fresh from db but it won't be automatically set in the current session.
         * 
         */
		recipe.setSoup(soup);

		soup.setRecipe(recipe);
		session.save(soup);

		session.getTransaction().commit();

	}

}
