package de.laliluna.cachetest;

import java.util.List;
import java.util.Random;

import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheException;
import net.sf.ehcache.CacheManager;


import org.hibernate.Session;

import de.laliluna.hibernate.InitSessionFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RandomNaturalIdThread extends Thread {

    private int max = 10;

    final static Logger log = LoggerFactory.getLogger(RandomNaturalIdThread.class);
    private boolean cacheQuery;

    public RandomNaturalIdThread(boolean cacheQuery) {
	super();
	this.cacheQuery = cacheQuery;
    }

    public void run() {

	log.info("##############starting: " + this);

	randomAccess();

    }

    private void randomAccess() {
	Session session = InitSessionFactory.getInstance().getCurrentSession();

	long total = 0;
	long start = 0;
	long totalTime = 0;
	long timePerRequest = 0;
	Random random = new Random(System.currentTimeMillis());

	try {
	    CacheManager cacheManager = CacheManager.getInstance();
	    Cache cache = cacheManager.getCache("myCache");

	    /* create a list of all administrationNumber */
	    List<String> numbers = session.createQuery(
		    "select c.administrationNumber from Computer c").list();
	    int maxAdministrationNumber = numbers.size();

	    for (int i = 0; i < 101; i++) {
		session.beginTransaction();
		start = System.currentTimeMillis();
		/*Computer d = (Computer) session.getNamedQuery(
			"computerByAdminNumber").setString(0, numbers.get(5))
			.uniqueResult();*/

		// Computer d = (Computer)
		// session.createCriteria(Computer.class) .add(
		// Restrictions.naturalId().set( "administrationNumber",
		// numbers.get(random.nextInt(5))))
		// .uniqueResult();
		// Computer d = (Computer)
		// session.createCriteria(Computer.class) .add(
		// Restrictions.eq( "administrationNumber",
		// numbers.get(random.nextInt(5))))
		// .setCacheable(cacheQuery).uniqueResult();

		 Computer d = (Computer) session.createQuery(
		 "from Computer where administrationNumber = ?")
		 .setString(0, numbers.get(random.nextInt(5)))
		 .setCacheable(false).uniqueResult();

		timePerRequest = (System.currentTimeMillis() - start);
		total += timePerRequest;
		totalTime += timePerRequest;
		session.getTransaction().commit();

		if (i % 100 == 0 && i > 0) {
		    double average = (total) / 100.0;

		    log.info("### Thread: " + this + " Hit count: "
			    + cache.getLiveCacheStatistics().getCacheHitCount() + " Size: "
			    + cache.getMemoryStoreSize() + " total:" + total
			    + " access speed per 100 get: " + average);

		    total = 0;
		}
		// short pause, we do not want to saturate the cpu
		try {
		    sleep(100);
		} catch (InterruptedException e) {
		    e.printStackTrace();
		}
	    }

	} catch (CacheException e) {
	    e.printStackTrace();
	}
	log.info("################# finish: " + this + " total time: "
		+ totalTime);

    }
}
